#pragma config(Sensor, S3,     TouchSensor,    sensorEV3_Touch, modeEV3Bump)
#pragma config(Sensor, S4,     Color,          sensorEV3_Color, modeEV3Color_Reflected)
#pragma config(Motor,  motorA,          Drive,         tmotorEV3_Large, PIDControl, encoder)
#pragma config(Motor,  motorB,          Shift,         tmotorEV3_Medium, PIDControl, encoder)
#pragma config(Motor,  motorC,          TiltPen,       tmotorEV3_Large, PIDControl, encoder)
//*!!Code automatically generated by 'ROBOTC' configuration wizard               !!*//

// Global constants
	const int Row[3] = {124,82,40};	// Display coordinates rows
	const int Col[3] = {110,70,30};	// Display coordinates columns
	const int Treshold2 = 75;				// If sensorValue[Color] > Treshold2 then field is empty
	const int Treshold1 = 40;				// If sensorValue[Color] < Treshold1 then field contains "O"
																	// If Treshold1 < sensorValue[Color] < Treshold2 then field contains "X"

// Global variables
int TTTValues[3][3]	= {						// 3x3 array containing values of TicTacToe field:
											 {0,0,0},		// 0 = empty
											 {0,0,0},		// 1 = x
											 {0,0,0}};	// 2 = o

bool TTTValuesSet[3][3] = {				// 3x3 array indicating if value is set to x or o
														{false,false,false},
														{false,false,false},
														{false,false,false}};

enum GameState {NextMove,Won,Lost,Draw};

//#include "TTT_TEST_Functions.h"
#include "TTT_Functions.h"

task main()
{

	GameState gState;
	bool GameReady = false;
	bool GameOver = false;
	int Player=0;						// 0 = opponent, 1 = EV3
	int Round;							// Game lasts max. 9 rounds
	int retError=0;					// Error code

	// Initialize game
	GameReady =	InitTTT();

	if (GameReady == true)
	{

		playSoundFile("Start");
		while(bSoundActive)
		sleep(1);

		// Draw TTT field
		DrawTTTField();

		// Player = 0: Opponent starts

		for(Round=0;Round<=8;++Round)
		{
			if(Player == 0)		// Opponents turn
			{
				writeDebugStreamLine("*** Opponent's turn,round %1d",Round);
				playSoundFile("Go");
				while(bSoundActive)
				sleep(1);
				resetBumpedValue(TouchSensor);
				repeatUntil(getBumpedValue(TouchSensor)==1);
				{
					// Opponent is ready when Touchsensor is pressed
					// Do nothing (EV3 brick will check for bumps automatically)
				}
				// Detect all fields
				sleep(1000);
				DetectAllFields();
			}
			else 							// EV3's turn
			{
				writeDebugStreamLine("*** EV3's turn,round %1d",Round);
				retError = SimpleTTTAlg();
				if (retError != 0)
				{
					playSoundFile("Error");
					while(bSoundActive)
					sleep(1);
					break;
				}
			}

			// Is there a winner?
			gState = CheckGameState(Round);
			switch (gState)
			{
				case Lost:
					// Oponent won
					playSoundFile("Good job");
					while(bSoundActive)
						sleep(4000);
					GameOver = true;
					break;

				case Won:
					// EV3 won
					playSoundFile("Fanfare");
					while(bSoundActive)
						sleep(4000);
					GameOver = true;
					break;

				case Draw:
					//It's a draw
					playSoundFile("Power down");
					while(bSoundActive)
						sleep(4000);
					GameOver = true;
					break;

				case NextMove:
					if (Player == 0)
					{
						// EV3 is nextplayer
						Player = 1;
					}
					else if (Player == 1)
					{
						// Opponent is next player
						Player = 0;
					}
					break;
				}

			if (GameOver == true)
			{
				// Game over
				playSoundFile("Game over");
				while(bSoundActive)
				sleep(10000);
				break;
			}
		}
	}
	else
	{
		playSoundFile("Error");
		while(bSoundActive)
		sleep(1);
	}

}
